<?php
/*****************************************************************************/
/* LogInOut.php                                                              */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$loginoutphpver = 'YaBB SE 1.5.1';

function Login ()
{
	global $txt, $yytitle, $cgi, $action, $color, $imagesdir, $Cookie_Length;
	global $reminderurl, $u;

	$yytitle = $txt[34];
	template_header();

	print '
		<br /><br />
		<form name="frmLogin" action="' . $cgi . ';action=login2" method="post">
			<table border="0" width="400" cellspacing="1" cellpadding="0" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">
				<tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '" width="100%">
						<table width="100%" cellspacing="0" cellpadding="3">
							<tr>
								<td class="titlebg" bgcolor="' . $color['titlebg'] . '" colspan="2">
									<img src="' . $imagesdir . '/login_sm.gif" alt="" />
									<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[34] . '</b></font>
								</td>
							</tr><tr>
								<td align="right" class="windowbg" bgcolor="' . $color['windowbg'] . '"><font size="2"><b>' . $txt[35] . ':</b></font></td>
								<td class="windowbg" bgcolor="' . $color['windowbg'] . '"><font size="2"><input type="text" name="user" size="20" value="' . $u . '" /></font></td>
							</tr><tr>
								<td align="right" class="windowbg" bgcolor="' . $color['windowbg'] . '"><font size="2"><b>' . $txt[36] . ':</b></font></td>
								<td class="windowbg" bgcolor="' . $color['windowbg'] . '"><font size="2"><input type="password" name="passwrd" size="20" /></font></td>
							</tr><tr>
								<td align="right" class="windowbg" bgcolor="' . $color['windowbg'] . '"><font size="2"><b>' . $txt[497] . ':</b></font></td>
								<td class="windowbg" bgcolor="' . $color['windowbg'] . '"><font size="2"><input type="text" name="cookielength" size="4" maxlength="4" value="' . $Cookie_Length . '" /></font></td>
							</tr><tr>
								<td align="right" class="windowbg" bgcolor="' . $color['windowbg'] . '"><font size="2"><b>' . $txt[508] . ':</b></font></td>
								<td class="windowbg" bgcolor="' . $color['windowbg'] . '"><font size="2"><input type="checkbox" name="cookieneverexp" /></font></td>
							</tr><tr>
								<td align="center" colspan="2" class="windowbg" bgcolor="' . $color['windowbg'] . '"><br /><input type="submit" value="' . $txt[34] . '" /></td>
							</tr><tr>
								<td align="center" colspan="2" class="windowbg" bgcolor="' . $color['windowbg'] . '"><a href="' . $cgi . ';action=reminder;what=input_user"><small>' . $txt[315] . '</small></a><br /><br /></td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</form>
		<script language="JavaScript" type="text/javascript"><!--
			document.frmLogin.user.focus();
		//--></script>';

	footer();
	obExit();
}

function Login2()
{
	global $txt, $settings, $username, $cookielength, $Cookie_Length, $user, $passwrd, $cookieneverexp, $db_prefix;
	global $pwseed, $cookiename, $password, $REMOTE_ADDR, $maintenance;
	global $language, $modSettings;

	if ($user == '')
		fatal_error($txt[37] . ' - ' . htmlspecialchars($passwrd));

	if ($passwrd == '')
		fatal_error($txt[38]);

	if (!preg_match("/^[\s0-9A-Za-z#%+,-\.:=?@^_]+$/", $user))
		fatal_error($txt[240]);

	if ($cookielength == $txt['yse50'])
	{
		$cookielength   = 1;
		$cookieneverexp   = 'on';
	}

	if (!is_numeric($cookielength))
		fatal_error(htmlspecialchars($cookieLength) . ' ' . $txt[337]);

	$request = mysql_query("
		SELECT passwd,realName,emailAddress,websiteTitle,websiteUrl,signature,posts,memberGroup,ICQ,AIM,YIM,gender,personalText,avatar,dateRegistered,location,birthdate,timeFormat,timeOffset,hideEmail,ID_MEMBER FROM {$db_prefix}members
		WHERE memberName='$user'") or database_error(__FILE__, __LINE__);
	$attempt = str_repeat('*', strlen($passwrd));

	if (mysql_num_rows($request) == 0)
		fatal_error($txt[40] . ' - ' . htmlspecialchars($user) . ': ' . htmlspecialchars($attempt));
	$settings = mysql_fetch_array($request);

	$md5_passwrd = md5_hmac($passwrd, strtolower($user));

	if ($settings[0] != $md5_passwrd)
	{
		if ($settings[0] == crypt($passwrd, substr($passwrd, 0, 2)) || $settings[0] == md5($passwrd))
		{
			mysql_query("
				UPDATE {$db_prefix}members
				SET passwd='$md5_passwrd'
				WHERE memberName='$user'") or database_error(__FILE__, __LINE__);
			$settings[0] = $md5_passwrd;
		}
		else
		{
			$settings[7] = '';
			fatal_error($txt[39] . ' - ' . htmlspecialchars($user) . ': ' . htmlspecialchars($attempt));
		}
	}
	$username = $settings['ID_MEMBER'];

	if ($cookielength < 1 || $cookielength > 525600)
		$cookielength = $Cookie_Length;

	if (!isset($cookieneverexp) || $cookieneverexp == '')
		$Cookie_Length = $cookielength;
	else
		$Cookie_Length = 525600;   // about 1 year

	$password = md5_hmac($md5_passwrd, $pwseed);

	$cookie_url = explode('<yse_sep>', url_parts());
	$cookie = serialize(array($settings['ID_MEMBER'], $password));
	$ctime = time() + (60 * $Cookie_Length);

	setCookie($cookiename, $cookie, $ctime, $cookie_url[1], $cookie_url[0]);
	

	$lastLog = time();
	$memIP = $REMOTE_ADDR;
	$result =  mysql_query("UPDATE {$db_prefix}members SET lastLogin='$lastLog',memberIP='$memIP' WHERE memberName='$user'") or database_error(__FILE__, __LINE__);

	LoadUserSettings();
	$request = mysql_query("DELETE FROM {$db_prefix}log_online WHERE identity=INET_ATON('$REMOTE_ADDR')") or database_error(__FILE__, __LINE__);
	$lngfile_result = mysql_query("SELECT lngfile FROM {$db_prefix}members WHERE memberName='$username'") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_array($lngfile_result);
	$chklngfile = $temp[0];

	if ($modSettings['userLanguage'] == 1 && $chklngfile != $language)
		if ($chklngfile != Null)
			include($chklngfile);

	if (!($maintenance == 1 && $settings[7] != 'Administrator'))
	{
		WriteLog();
		redirectinternal();
	}
	else
		Logout();
}

function Logout ()
{
	global $username, $password, $cookiename, $settings, $realname, $realemail, $ID_MEMBER;
	global $HTTP_COOKIE_VARS, $maintenance, $db_prefix, $sourcedir, $modSettings, $guestaccess;
	
	checkSession('get');

	// Write log
	$request = mysql_query("DELETE FROM {$db_prefix}log_online WHERE identity='$ID_MEMBER'") or database_error(__FILE__, __LINE__);

	$cookie_url = explode('<yse_sep>', url_parts());
	setCookie($cookiename, '', time() - 3600, $cookie_url[1], $cookie_url[0]);

	$username = 'Guest';
	$password = '';
	$settings = array(7 => '');
	$realname = '';
	$realemail = '';
	$HTTP_COOKIE_VARS = array();

	banning();

	if ($maintenance == 1 && $settings[7] != 'Administrator')
	{
		include_once ("$sourcedir/Maintenance.php");
		InMaintenance();
	}

	if ($guestaccess == 1)
		redirectinternal();
	else
		kickguest();
}

?>